//----------------------------------------------------------------------
//            Test for Win 95/98/NT FPU accuracy degradation
//                J.A.Wrotniak, pan_andrzej@csi.com
//            http://www.freeflight.com/wrotniak/tfpu.html
//----------------------------------------------------------------------

unit tfpumain;

//----------------------------------------------------------------------
                              interface
//----------------------------------------------------------------------

uses
  Forms, Classes, StdCtrls, Controls, ExtCtrls, ComCtrls,
  Graphics;

//----------------------------------------------------------------------

type
  TxMain = class(TForm)
  xTimer: TTimer;
  xLabel: TPanel;
  Line1: TLabel;
  Line2: TLabel;
  Line3: TLabel;
  Line4: TLabel;
  Line5: TLabel;
  Line6: TLabel;
  Line7: TLabel;
  Line8: TLabel;
  procedure xTimerTimer(Sender: TObject);
  end;

//----------------------------------------------------------------------

var
  xMain: TxMain;

//----------------------------------------------------------------------
                             implementation
//----------------------------------------------------------------------

{$R *.DFM}

//----------------------------------------------------------------------

procedure CheckFPU( var bad: boolean; var s: string );
const
  x: extended = 1.0;        // The extended type uses full FPU accuracy
  y: extended = 3.0;
  z: extended = 0.33333333333333333333; // Note 20 3's
var
  t: extended;
begin
  t := x/y-z;               // test operation
  bad := abs(t) > 1E-19;    // bad FPU flag
  Str(t:24:18,s);           // text output
  end;

//----------------------------------------------------------------------

procedure TxMain.xTimerTimer(Sender: TObject);   // called every second
const
  col: array [boolean] of integer = (clLime,clRed);
var
  s: string;
  bad: boolean;
begin
  CheckFPU(bad,s);              // call the test function
  xLabel.Caption := s;          // show the result; should be all zeros
  with xLabel.Font do           // blink yellow/red or yellow/green
    if Color = clYellow then
      Color := col[bad]
    else
      Color := clYellow;
  end;

//----------------------------------------------------------------------

end.

